1 -
Understanding the ai.edgelq.com service APIv1, in proto package ntt.ai.v1.
Here is the list of resources supported in AI service APIv1:
CapabilityTemplate Resource
CapabilityTemplate Resource
Name patterns:
capabilityTemplates/{capability_template}projects/{project}/capabilityTemplates/{capability_template}
Parent resources:
This section covers the methods
and messages to interact
with CapabilityTemplate resource.
CapabilityTemplate Methods
Here is the list of CapabilityTemplate resource methods:
GetCapabilityTemplate Method
GetCapabilityTemplate
rpc GetCapabilityTemplate(GetCapabilityTemplateRequest) returns (CapabilityTemplate)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/capabilityTemplates.get
The equivalent REST API is:
GET /v1/{name=capabilityTemplates/*}
GET /v1/{name=projects/*/capabilityTemplates/*}
BatchGetCapabilityTemplates Method
BatchGetCapabilityTemplates
rpc BatchGetCapabilityTemplates(BatchGetCapabilityTemplatesRequest) returns (BatchGetCapabilityTemplatesResponse)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/capabilityTemplates.batchGet
The equivalent REST API is:
GET /v1/capabilityTemplates:batchGet
ListCapabilityTemplates Method
ListCapabilityTemplates
rpc ListCapabilityTemplates(ListCapabilityTemplatesRequest) returns (ListCapabilityTemplatesResponse)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/capabilityTemplates.list
The equivalent REST API is:
GET /v1/capabilityTemplates
GET /v1/{parent=projects/*}/capabilityTemplates
WatchCapabilityTemplate Method
WatchCapabilityTemplate
rpc WatchCapabilityTemplate(WatchCapabilityTemplateRequest) returns (WatchCapabilityTemplateResponse)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/capabilityTemplates.watch
The equivalent REST API is:
POST /v1/{name=capabilityTemplates/*}:watch
POST /v1/{name=projects/*/capabilityTemplates/*}:watch
WatchCapabilityTemplates Method
WatchCapabilityTemplates
rpc WatchCapabilityTemplates(WatchCapabilityTemplatesRequest) returns (WatchCapabilityTemplatesResponse)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/capabilityTemplates.watch
The equivalent REST API is:
POST /v1/capabilityTemplates:watch
POST /v1/{parent=projects/*}/capabilityTemplates:watch
CreateCapabilityTemplate Method
CreateCapabilityTemplate
rpc CreateCapabilityTemplate(CreateCapabilityTemplateRequest) returns (CapabilityTemplate)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/capabilityTemplates.create
The equivalent REST API is:
POST /v1/capabilityTemplates (BODY: capability_template)
POST /v1/{parent=projects/*}/capabilityTemplates
UpdateCapabilityTemplate Method
UpdateCapabilityTemplate
rpc UpdateCapabilityTemplate(UpdateCapabilityTemplateRequest) returns (CapabilityTemplate)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/capabilityTemplates.update
The equivalent REST API is:
PUT /v1/{capability_template.name=capabilityTemplates/*} (BODY: capability_template)
PUT /v1/{capability_template.name=projects/*/capabilityTemplates/*}
DeleteCapabilityTemplate Method
DeleteCapabilityTemplate
rpc DeleteCapabilityTemplate(DeleteCapabilityTemplateRequest) returns (Empty)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/capabilityTemplates.delete
The equivalent REST API is:
DELETE /v1/{name=capabilityTemplates/*}
DELETE /v1/{name=projects/*/capabilityTemplates/*}
PreviewTemplateTools
rpc PreviewTemplateTools(PreviewTemplateToolsRequest) returns (PreviewTemplateToolsResponse)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/capabilityTemplates.previewTools
The equivalent REST API is:
POST /v1/{name=capabilityTemplates/*}:previewTools
POST /v1/{name=projects/*/capabilityTemplates/*}:previewTools
CapabilityTemplate Messages
Here is the list of CapabilityTemplate resource messages:
CapabilityTemplate Message
| Name | Type | Description |
|---|
| name | string (name of CapabilityTemplate) | Name of CapabilityTemplate When creating a new instance, this field is optional and if not provided, it will be generated automatically. Last ID segment must conform to the following regex: [a-z][a-z0-9\-]{0,28}[a-z0-9] |
| metadata | Meta | Metadata is an object with information like create, update and delete time (for async deleted resources), has user labels/annotations, sharding information, multi-region syncing information and may have non-schema owners (useful for taking ownership of resources belonging to lower level services by higher ones). |
| description | string | Human-readable description |
| connectors | repeated string (reference to Connector) | Connectors to include |
| rag_config | RAGConfig | RAG configuration (optional) |
| display_name | string | Human-readable display name |
| reasoning | ReasoningConfig | Reasoning/thinking configuration and limits |
| max_output_tokens | int32 | Maximum output tokens (overrides ChatModel’s default if set) |
| system_prompt | string | When set, this prompt will be used instead of a default system prompt. |
| system_prompt_append | PromptAppendTemplate | Optional: a templated append that will be rendered and appended to the base system prompt (or the user input for client provided variables). |
| disable_input_token_cache | bool | When true, disables Anthropic prompt caching (default: caching enabled) |
| allowed_models | repeated string (reference to ChatModel) | Allowed chat models for this template (optional) If empty, any model can be used with this template If specified, only models in this list can be used with this template This allows organizations to control which models are used for specific use cases, capabilities, or compliance requirements |
| tool_safety | ToolSafetyConfig | Tool safety configuration for loop detection (optional) |
| default_model | string (name of ChatModel) | Default model for this template (optional) |
| user_prompt_templates | repeated UserPromptTemplate | User prompt template library for this capability Client-side only: server stores, client renders and executes |
GetCapabilityTemplateRequest Message
A request message of the GetCapabilityTemplate method.
| Name | Type | Description |
|---|
| name | string (name of CapabilityTemplate) | Name of ntt.ai.v1.CapabilityTemplate |
| field_mask | .google.protobuf.FieldMask | A list of extra fields to be obtained for each response item on top of fields defined by request field view |
| view | View | View defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask |
BatchGetCapabilityTemplatesRequest Message
A request message of the BatchGetCapabilityTemplates method.
| Name | Type | Description |
|---|
| names | repeated string (name of CapabilityTemplate) | Names of CapabilityTemplates |
| field_mask | .google.protobuf.FieldMask | A list of extra fields to be obtained for each response item on top of fields defined by request field view |
| view | View | View defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask |
BatchGetCapabilityTemplatesResponse Message
A response message of the BatchGetCapabilityTemplates method.
ListCapabilityTemplatesRequest Message
A request message of the ListCapabilityTemplates method.
| Name | Type | Description |
|---|
| parent | string (parent name of CapabilityTemplate) | Parent name of ntt.ai.v1.CapabilityTemplate |
| page_size | int32 | Requested page size. Server may return fewer CapabilityTemplates than requested. If unspecified, server will pick an appropriate default. |
| page_token | string (cursor of CapabilityTemplate) | A token identifying a page of results the server should return. Typically, this is the value of ListCapabilityTemplatesResponse.next_page_token. |
| order_by | string (orderBy of CapabilityTemplate) | Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination list of field path with order directive, either ‘asc’ or ‘desc’. If direction is not provided, ‘asc’ is assumed. e.g. “state.nested_field asc, state.something.else desc, theme” |
| filter | string (filter of CapabilityTemplate) | Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL |
| field_mask | .google.protobuf.FieldMask | A list of extra fields to be obtained for each response item on top of fields defined by request field view |
| view | View | View defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask |
| include_paging_info | bool | Indicates if list response should contain total count and offset (fields current_offset and total_results_count). |
ListCapabilityTemplatesResponse Message
A response message of the ListCapabilityTemplates method.
| Name | Type | Description |
|---|
| capability_templates | repeated CapabilityTemplate | The list of CapabilityTemplates |
| prev_page_token | string (cursor of CapabilityTemplate) | A token to retrieve previous page of results. Pass this value in the ListCapabilityTemplatesRequest.page_token. |
| next_page_token | string (cursor of CapabilityTemplate) | A token to retrieve next page of results. Pass this value in the ListCapabilityTemplatesRequest.page_token. |
| current_offset | int32 | Current offset from the first page or 0 if no page tokens were given, paging info was not requested or there was an error while trying to get it). Page index can be computed from offset and limit provided in a request. |
| total_results_count | int32 | Number of total CapabilityTemplates across all pages or 0, if there are no items, paging info was not requested or there was an error while trying to get it. |
WatchCapabilityTemplateRequest Message
A request message of the WatchCapabilityTemplate method.
| Name | Type | Description |
|---|
| name | string (name of CapabilityTemplate) | Name of ntt.ai.v1.CapabilityTemplate |
| field_mask | .google.protobuf.FieldMask | A list of extra fields to be obtained for each response item on top of fields defined by request field view |
| view | View | View defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask |
WatchCapabilityTemplateResponse Message
A response message of the WatchCapabilityTemplate method.
WatchCapabilityTemplatesRequest Message
A request message of the WatchCapabilityTemplates method.
| Name | Type | Description |
|---|
| type | WatchType | Type of a watch. Identifies how server stream data to a client, which fields in a request are allowed and which fields in response are relevant. |
| parent | string (parent name of CapabilityTemplate) | Parent name of ntt.ai.v1.CapabilityTemplate |
| page_size | int32 | Requested page size. Server may return fewer CapabilityTemplates than requested. If unspecified, server will pick an appropriate default. Can be populated only for stateful watch type. |
| page_token | string (cursor of CapabilityTemplate) | A token identifying a page of results the server should return. Can be populated only for stateful watch type. |
| order_by | string (orderBy of CapabilityTemplate) | Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination Can be populated only for stateful watch type. |
| resume_token | string | A token identifying watch resume point from previous session. Can be populated only for stateless watch type. |
| starting_time | .google.protobuf.Timestamp | Point in the time from which we want to start getting updates. This field can be populated only for stateless watch type and if resume token is not known yet. If specified, initial snapshot will NOT be provided. It is assumed client can obtain it using separate means. Watch responses will contain resume tokens which should be used to resume broken connection. |
| filter | string (filter of CapabilityTemplate) | Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL |
| field_mask | .google.protobuf.FieldMask | A list of extra fields to be obtained for each response item on top of fields defined by request field view Changes to CapabilityTemplate that don’t affect any of masked fields won’t be sent back. |
| view | View | View defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask Changes to CapabilityTemplate that don’t affect any of masked fields won’t be sent back. |
| max_chunk_size | int32 | Maximum amount of changes in each response message. Query result response is divided on the server side into chunks with size of a specified amount to limit memory footprint of each message. Responses will hold information whether more elements will continue for the actual change. If unspecified, server will pick an appropriate default. |
WatchCapabilityTemplatesResponse Message
A response message of the WatchCapabilityTemplates method.
| Name | Type | Description |
|---|
| capability_template_changes | repeated CapabilityTemplateChange | Changes of CapabilityTemplates |
| is_current | bool | If request specified max_chunk_size (or this limit was enforced if stateless watch has been chosen), then responses with “full changeset” will be divided into chunks. Client should keep receiving messages and, once is_current has value true, combine this recent message with all previous ones where is_current is false. If this is the first is_current in a whole watch stream, then it means that client should have, at this moment, contain snapshot of the current situation (or more accurately, snapshot of situation at the moment of request). All CapabilityTemplates will be of type Added/Current (depending on watch_type specified in the request). Further responses will be incremental - however messages may still be chunked and is_current logic still applies. is_current is always true for stateful watch if max_chunk_size was left to 0. |
| page_token_change | WatchCapabilityTemplatesResponse.PageTokenChange | When present, PageTokens used for page navigation should be updated. Present only if is_current is true (last chunk). |
| resume_token | string | Token that can be used if current connection drops and client needs to reconnect. Populated only for stateless watch type. Present only if is_current is true (last chunk). |
| snapshot_size | int64 | Server may occasionally send information how many resources should client have in its state so far (response message without any changes, but with snapshot_size field specified). If client has different value than the one sent by the server, then it should be treated by a client as an error and should reconnect. If value is smaller then 0, then client should ignore this field as unpopulated. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will be never sent together with is_current, is_soft_reset and is_hard_reset flags. |
| is_soft_reset | bool | In case of internal issue server may send response message with this flag. It indicates that client should drop all changes from recent responses where is_current is false only! If last message had is_current set to true, client should do nothing and process normally. Resume token received before is still valid. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will never be sent along with is_current, is_hard_reset or snapshot_size. |
| is_hard_reset | bool | In case of internal issue server may send response message with this flag. After receiving, client should clear whole state (drop all changes received so far) as server will send new snapshot (CapabilityTemplates will contains changes of type Current only). Any resume tokens should be discarded as well. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will never be sent along with is_current, is_soft_reset or snapshot_size. |
WatchCapabilityTemplatesResponse.PageTokenChange Message
| Name | Type | Description |
|---|
| prev_page_token | string (cursor of CapabilityTemplate) | New token to retrieve previous page of results. |
| next_page_token | string (cursor of CapabilityTemplate) | New token to retrieve next page of results. |
CreateCapabilityTemplateRequest Message
A request message of the CreateCapabilityTemplate method.
CreateCapabilityTemplateRequest.ResponseMask Message
ResponseMask allows client to reduce response message size.
| Name | Type | Description |
|---|
| skip_entire_response_body | bool | If this flag has value true, then response will contain just empty resource without any fields populated. |
| body_mask | .google.protobuf.FieldMask | If this field is populated, then resource in response will contain only specific fields. |
UpdateCapabilityTemplateRequest Message
A request message of the UpdateCapabilityTemplate method.
| Name | Type | Description |
|---|
| capability_template | CapabilityTemplate | CapabilityTemplate resource body |
| update_mask | .google.protobuf.FieldMask | FieldMask applied to request - change will be applied only for fields in the mask |
| cas | UpdateCapabilityTemplateRequest.CAS | Conditional update applied to request if update should be executed only for specific resource state. If this field is populated, then server will fetch existing resource, compare with the one stored in the cas field (after applying field mask) and proceed with update only and only if they match. Otherwise RPC error Aborted will be returned. |
| allow_missing | bool | If set to true, and the resource is not found, a new resource will be created. In this situation, ‘field_mask’ is ignored. https://google.aip.dev/134#create-or-update |
| response_mask | UpdateCapabilityTemplateRequest.ResponseMask | reduce message response size. |
UpdateCapabilityTemplateRequest.CAS Message
CAS - Compare and Swap. This object is used if user wants to make update
conditional based upon previous resource version.
| Name | Type | Description |
|---|
| conditional_state | CapabilityTemplate | Conditional desired state of a resource before update. |
| field_mask | .google.protobuf.FieldMask | Field paths from conditional state of resource server should check and compare. |
UpdateCapabilityTemplateRequest.ResponseMask Message
ResponseMask allows client to reduce response message size.
| Name | Type | Description |
|---|
| skip_entire_response_body | bool | If this flag has value true, then response will contain just empty resource without any fields populated. Field body_mask is ignored if set. |
| updated_fields_only | bool | Include all fields that were actually updated during processing. Note this may be larger than update mask if some fields were computed additionally. Name is added as well. |
| body_mask | .google.protobuf.FieldMask | If this field is populated, then resource in response will contain only specific fields. If skip_entire_response_body is true, this field is ignored. |
DeleteCapabilityTemplateRequest Message
A request message of the DeleteCapabilityTemplate method.
| Name | Type | Description |
|---|
| name | string (name of CapabilityTemplate) | Name of ntt.ai.v1.CapabilityTemplate |
| allow_missing | bool | If set to true, and the resource is not found, method will be successful and will not return NotFound error. |
A request message of the PreviewTemplateTools method.
| Name | Type | Description |
|---|
| name | string (name of CapabilityTemplate) | Name of ntt.ai.v1.CapabilityTemplate |
| client_tools | repeated ToolDefinition | Optional: Client tools to include in the preview |
A response message of the PreviewTemplateTools method.
| Name | Type | Description |
|---|
| tools | repeated ToolDefinition | All tools that would be available with this template (after applying allow/deny patterns and including client tools) |
| errors | repeated string | Any errors encountered during tool discovery |
ChatModel Resource
ChatModel Resource represents deployment of an AI chat model.
Name patterns:
chatModels/{chat_model}projects/{project}/chatModels/{chat_model}
Parent resources:
This section covers the methods
and messages to interact
with ChatModel resource.
ChatModel Methods
Here is the list of ChatModel resource methods:
GetChatModel Method
GetChatModel
rpc GetChatModel(GetChatModelRequest) returns (ChatModel)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/chatModels.get
The equivalent REST API is:
GET /v1/{name=chatModels/*}
GET /v1/{name=projects/*/chatModels/*}
BatchGetChatModels Method
BatchGetChatModels
rpc BatchGetChatModels(BatchGetChatModelsRequest) returns (BatchGetChatModelsResponse)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/chatModels.batchGet
The equivalent REST API is:
GET /v1/chatModels:batchGet
ListChatModels Method
ListChatModels
rpc ListChatModels(ListChatModelsRequest) returns (ListChatModelsResponse)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/chatModels.list
The equivalent REST API is:
GET /v1/{parent=projects/*}/chatModels
WatchChatModel Method
WatchChatModel
rpc WatchChatModel(WatchChatModelRequest) returns (WatchChatModelResponse)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/chatModels.watch
The equivalent REST API is:
POST /v1/{name=chatModels/*}:watch
POST /v1/{name=projects/*/chatModels/*}:watch
WatchChatModels Method
WatchChatModels
rpc WatchChatModels(WatchChatModelsRequest) returns (WatchChatModelsResponse)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/chatModels.watch
The equivalent REST API is:
POST /v1/chatModels:watch
POST /v1/{parent=projects/*}/chatModels:watch
CreateChatModel Method
CreateChatModel
rpc CreateChatModel(CreateChatModelRequest) returns (ChatModel)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/chatModels.create
The equivalent REST API is:
POST /v1/chatModels (BODY: chat_model)
POST /v1/{parent=projects/*}/chatModels
UpdateChatModel Method
UpdateChatModel
rpc UpdateChatModel(UpdateChatModelRequest) returns (ChatModel)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/chatModels.update
The equivalent REST API is:
PUT /v1/{chat_model.name=chatModels/*} (BODY: chat_model)
PUT /v1/{chat_model.name=projects/*/chatModels/*}
DeleteChatModel Method
DeleteChatModel
rpc DeleteChatModel(DeleteChatModelRequest) returns (Empty)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/chatModels.delete
The equivalent REST API is:
DELETE /v1/{name=chatModels/*}
DELETE /v1/{name=projects/*/chatModels/*}
ChatModel Messages
Here is the list of ChatModel resource messages:
ChatModel Message
| Name | Type | Description |
|---|
| name | string (name of ChatModel) | Name of ChatModel When creating a new instance, this field is optional and if not provided, it will be generated automatically. Last ID segment must conform to the following regex: [a-z][a-z0-9\-]{0,28}[a-z0-9] |
| metadata | Meta | Metadata is an object with information like create, update and delete time (for async deleted resources), has user labels/annotations, sharding information, multi-region syncing information and may have non-schema owners (useful for taking ownership of resources belonging to lower level services by higher ones). |
| azure_open_ai | ChatModel.AzureOpenAi | |
| openai_compatible | ChatModel.OpenAICompatible | |
| anthropic | ChatModel.Anthropic | |
| gemini | ChatModel.Gemini | |
| display_name | string | Human-readable display name |
| cost | ChatModel.Cost | Optional cost metadata (pricing per 1M tokens). |
| retired | bool | When true, this model is retired: hidden from ChatModel listings by default and blocked for new chats/responses. Existing conversations stay readable and can be continued by selecting a non-retired model. |
ChatModel.OpenAICompatible Message
| Name | Type | Description |
|---|
| api_key | string (reference to Secret) | |
| model | string | Model name or Azure deployment name |
| base_url | string | Optional: Custom endpoint for compatible APIs |
| organization | string | Optional: OpenAI organization ID |
| azure_endpoint | string | Optional: Azure-specific endpoint (e.g., https://myresource.openai.azure.com) |
| azure_api_version | string | Optional: Azure API version (e.g., “2024-06-01”) |
| max_output_tokens | int32 | Maximum output tokens |
| device | string (reference to Device) | Optional: route requests through proxies to an OpenAI-compatible endpoint reachable from this device. |
ChatModel.Anthropic Message
| Name | Type | Description |
|---|
| api_key | string (reference to Secret) | |
| model | string | Model name (e.g., “claude-3-opus”, “claude-3-sonnet”) |
| base_url | string | Optional: Custom endpoint |
| max_output_tokens | int32 | Maximum output tokens (must be >= 4096 for Anthropic) |
| thinking_mode | ChatModel.Anthropic.ThinkingMode | |
ChatModel.Gemini Message
| Name | Type | Description |
|---|
| api_key | string (reference to Secret) | |
| model | string | Model name (e.g., “gemini-pro”, “gemini-ultra”) |
| max_output_tokens | int32 | Maximum output tokens |
ChatModel.AzureOpenAi Message
| Name | Type | Description |
|---|
| endpoint | string | Azure OpenAI endpoint (e.g., https://myresource.openai.azure.com) |
| api_key | string (reference to Secret) | Azure API key |
| deployment_name | string | Azure deployment name |
| api_version | string | API version (e.g., “2024-10-21”) |
| max_output_tokens | int32 | Maximum output tokens |
ChatModel.Cost Message
Cost captures pricing per 1M tokens for each billing bucket.
| Name | Type | Description |
|---|
| input_per_million | .google.type.Money | Cost for uncached input tokens per 1M tokens. |
| cached_input_per_million | .google.type.Money | Cost for cached input tokens per 1M tokens (discounted rate). |
| cache_write_five_min_per_million | .google.type.Money | Cost for cache writes with a 5 minute TTL per 1M tokens. |
| cache_write_one_hour_per_million | .google.type.Money | Cost for cache writes with a 1 hour TTL per 1M tokens. |
| output_per_million | .google.type.Money | Cost for output tokens per 1M tokens. |
GetChatModelRequest Message
A request message of the GetChatModel method.
| Name | Type | Description |
|---|
| name | string (name of ChatModel) | Name of ntt.ai.v1.ChatModel |
| field_mask | .google.protobuf.FieldMask | A list of extra fields to be obtained for each response item on top of fields defined by request field view |
| view | View | View defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask |
BatchGetChatModelsRequest Message
A request message of the BatchGetChatModels method.
| Name | Type | Description |
|---|
| names | repeated string (name of ChatModel) | Names of ChatModels |
| field_mask | .google.protobuf.FieldMask | A list of extra fields to be obtained for each response item on top of fields defined by request field view |
| view | View | View defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask |
BatchGetChatModelsResponse Message
A response message of the BatchGetChatModels method.
| Name | Type | Description |
|---|
| chat_models | repeated ChatModel | found ChatModels |
| missing | repeated string (name of ChatModel) | list of not found ChatModels |
ListChatModelsRequest Message
A request message of the ListChatModels method.
| Name | Type | Description |
|---|
| parent | string (parent name of ChatModel) | Parent name of ntt.ai.v1.ChatModel |
| page_size | int32 | Requested page size. Server may return fewer ChatModels than requested. If unspecified, server will pick an appropriate default. |
| page_token | string (cursor of ChatModel) | A token identifying a page of results the server should return. Typically, this is the value of ListChatModelsResponse.next_page_token. |
| order_by | string (orderBy of ChatModel) | Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination list of field path with order directive, either ‘asc’ or ‘desc’. If direction is not provided, ‘asc’ is assumed. e.g. “state.nested_field asc, state.something.else desc, theme” |
| filter | string (filter of ChatModel) | Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL |
| field_mask | .google.protobuf.FieldMask | A list of extra fields to be obtained for each response item on top of fields defined by request field view |
| view | View | View defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask |
| include_paging_info | bool | Indicates if list response should contain total count and offset (fields current_offset and total_results_count). |
ListChatModelsResponse Message
A response message of the ListChatModels method.
| Name | Type | Description |
|---|
| chat_models | repeated ChatModel | The list of ChatModels |
| prev_page_token | string (cursor of ChatModel) | A token to retrieve previous page of results. Pass this value in the ListChatModelsRequest.page_token. |
| next_page_token | string (cursor of ChatModel) | A token to retrieve next page of results. Pass this value in the ListChatModelsRequest.page_token. |
| current_offset | int32 | Current offset from the first page or 0 if no page tokens were given, paging info was not requested or there was an error while trying to get it). Page index can be computed from offset and limit provided in a request. |
| total_results_count | int32 | Number of total ChatModels across all pages or 0, if there are no items, paging info was not requested or there was an error while trying to get it. |
WatchChatModelRequest Message
A request message of the WatchChatModel method.
| Name | Type | Description |
|---|
| name | string (name of ChatModel) | Name of ntt.ai.v1.ChatModel |
| field_mask | .google.protobuf.FieldMask | A list of extra fields to be obtained for each response item on top of fields defined by request field view |
| view | View | View defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask |
WatchChatModelResponse Message
A response message of the WatchChatModel method.
WatchChatModelsRequest Message
A request message of the WatchChatModels method.
| Name | Type | Description |
|---|
| type | WatchType | Type of a watch. Identifies how server stream data to a client, which fields in a request are allowed and which fields in response are relevant. |
| parent | string (parent name of ChatModel) | Parent name of ntt.ai.v1.ChatModel |
| page_size | int32 | Requested page size. Server may return fewer ChatModels than requested. If unspecified, server will pick an appropriate default. Can be populated only for stateful watch type. |
| page_token | string (cursor of ChatModel) | A token identifying a page of results the server should return. Can be populated only for stateful watch type. |
| order_by | string (orderBy of ChatModel) | Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination Can be populated only for stateful watch type. |
| resume_token | string | A token identifying watch resume point from previous session. Can be populated only for stateless watch type. |
| starting_time | .google.protobuf.Timestamp | Point in the time from which we want to start getting updates. This field can be populated only for stateless watch type and if resume token is not known yet. If specified, initial snapshot will NOT be provided. It is assumed client can obtain it using separate means. Watch responses will contain resume tokens which should be used to resume broken connection. |
| filter | string (filter of ChatModel) | Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL |
| field_mask | .google.protobuf.FieldMask | A list of extra fields to be obtained for each response item on top of fields defined by request field view Changes to ChatModel that don’t affect any of masked fields won’t be sent back. |
| view | View | View defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask Changes to ChatModel that don’t affect any of masked fields won’t be sent back. |
| max_chunk_size | int32 | Maximum amount of changes in each response message. Query result response is divided on the server side into chunks with size of a specified amount to limit memory footprint of each message. Responses will hold information whether more elements will continue for the actual change. If unspecified, server will pick an appropriate default. |
WatchChatModelsResponse Message
A response message of the WatchChatModels method.
| Name | Type | Description |
|---|
| chat_model_changes | repeated ChatModelChange | Changes of ChatModels |
| is_current | bool | If request specified max_chunk_size (or this limit was enforced if stateless watch has been chosen), then responses with “full changeset” will be divided into chunks. Client should keep receiving messages and, once is_current has value true, combine this recent message with all previous ones where is_current is false. If this is the first is_current in a whole watch stream, then it means that client should have, at this moment, contain snapshot of the current situation (or more accurately, snapshot of situation at the moment of request). All ChatModels will be of type Added/Current (depending on watch_type specified in the request). Further responses will be incremental - however messages may still be chunked and is_current logic still applies. is_current is always true for stateful watch if max_chunk_size was left to 0. |
| page_token_change | WatchChatModelsResponse.PageTokenChange | When present, PageTokens used for page navigation should be updated. Present only if is_current is true (last chunk). |
| resume_token | string | Token that can be used if current connection drops and client needs to reconnect. Populated only for stateless watch type. Present only if is_current is true (last chunk). |
| snapshot_size | int64 | Server may occasionally send information how many resources should client have in its state so far (response message without any changes, but with snapshot_size field specified). If client has different value than the one sent by the server, then it should be treated by a client as an error and should reconnect. If value is smaller then 0, then client should ignore this field as unpopulated. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will be never sent together with is_current, is_soft_reset and is_hard_reset flags. |
| is_soft_reset | bool | In case of internal issue server may send response message with this flag. It indicates that client should drop all changes from recent responses where is_current is false only! If last message had is_current set to true, client should do nothing and process normally. Resume token received before is still valid. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will never be sent along with is_current, is_hard_reset or snapshot_size. |
| is_hard_reset | bool | In case of internal issue server may send response message with this flag. After receiving, client should clear whole state (drop all changes received so far) as server will send new snapshot (ChatModels will contains changes of type Current only). Any resume tokens should be discarded as well. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will never be sent along with is_current, is_soft_reset or snapshot_size. |
WatchChatModelsResponse.PageTokenChange Message
| Name | Type | Description |
|---|
| prev_page_token | string (cursor of ChatModel) | New token to retrieve previous page of results. |
| next_page_token | string (cursor of ChatModel) | New token to retrieve next page of results. |
CreateChatModelRequest Message
A request message of the CreateChatModel method.
CreateChatModelRequest.ResponseMask Message
ResponseMask allows client to reduce response message size.
| Name | Type | Description |
|---|
| skip_entire_response_body | bool | If this flag has value true, then response will contain just empty resource without any fields populated. |
| body_mask | .google.protobuf.FieldMask | If this field is populated, then resource in response will contain only specific fields. |
UpdateChatModelRequest Message
A request message of the UpdateChatModel method.
| Name | Type | Description |
|---|
| chat_model | ChatModel | ChatModel resource body |
| update_mask | .google.protobuf.FieldMask | FieldMask applied to request - change will be applied only for fields in the mask |
| cas | UpdateChatModelRequest.CAS | Conditional update applied to request if update should be executed only for specific resource state. If this field is populated, then server will fetch existing resource, compare with the one stored in the cas field (after applying field mask) and proceed with update only and only if they match. Otherwise RPC error Aborted will be returned. |
| allow_missing | bool | If set to true, and the resource is not found, a new resource will be created. In this situation, ‘field_mask’ is ignored. https://google.aip.dev/134#create-or-update |
| response_mask | UpdateChatModelRequest.ResponseMask | reduce message response size. |
UpdateChatModelRequest.CAS Message
CAS - Compare and Swap. This object is used if user wants to make update
conditional based upon previous resource version.
| Name | Type | Description |
|---|
| conditional_state | ChatModel | Conditional desired state of a resource before update. |
| field_mask | .google.protobuf.FieldMask | Field paths from conditional state of resource server should check and compare. |
UpdateChatModelRequest.ResponseMask Message
ResponseMask allows client to reduce response message size.
| Name | Type | Description |
|---|
| skip_entire_response_body | bool | If this flag has value true, then response will contain just empty resource without any fields populated. Field body_mask is ignored if set. |
| updated_fields_only | bool | Include all fields that were actually updated during processing. Note this may be larger than update mask if some fields were computed additionally. Name is added as well. |
| body_mask | .google.protobuf.FieldMask | If this field is populated, then resource in response will contain only specific fields. If skip_entire_response_body is true, this field is ignored. |
DeleteChatModelRequest Message
A request message of the DeleteChatModel method.
| Name | Type | Description |
|---|
| name | string (name of ChatModel) | Name of ntt.ai.v1.ChatModel |
| allow_missing | bool | If set to true, and the resource is not found, method will be successful and will not return NotFound error. |
ChatModel Enumerations
Here is the list of ChatModel resource enumerations:
ChatModel.Anthropic.ThinkingMode Enumeration
Which Messages thinking wire format this deployment accepts.
UNSPECIFIED and EXTENDED send enabled + budget_tokens.
ADAPTIVE sends adaptive + output_config.effort (Sonnet 5, Opus 4.7+).
Do not infer this from model; Foundry deployment names can disagree
with the underlying Claude model.
| Name | Description |
|---|
| THINKING_MODE_UNSPECIFIED | |
| THINKING_MODE_EXTENDED | |
| THINKING_MODE_ADAPTIVE | |
Connector Resource
Connector Resource
Name patterns:
connectors/{connector}projects/{project}/connectors/{connector}
Parent resources:
This section covers the methods
and messages to interact
with Connector resource.
Connector Methods
Here is the list of Connector resource methods:
GetConnector Method
GetConnector
rpc GetConnector(GetConnectorRequest) returns (Connector)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/connectors.get
The equivalent REST API is:
GET /v1/{name=connectors/*}
GET /v1/{name=projects/*/connectors/*}
BatchGetConnectors Method
BatchGetConnectors
rpc BatchGetConnectors(BatchGetConnectorsRequest) returns (BatchGetConnectorsResponse)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/connectors.batchGet
The equivalent REST API is:
GET /v1/connectors:batchGet
ListConnectors Method
ListConnectors
rpc ListConnectors(ListConnectorsRequest) returns (ListConnectorsResponse)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/connectors.list
The equivalent REST API is:
GET /v1/{parent=projects/*}/connectors
WatchConnector Method
WatchConnector
rpc WatchConnector(WatchConnectorRequest) returns (WatchConnectorResponse)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/connectors.watch
The equivalent REST API is:
POST /v1/{name=connectors/*}:watch
POST /v1/{name=projects/*/connectors/*}:watch
WatchConnectors Method
WatchConnectors
rpc WatchConnectors(WatchConnectorsRequest) returns (WatchConnectorsResponse)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/connectors.watch
The equivalent REST API is:
POST /v1/connectors:watch
POST /v1/{parent=projects/*}/connectors:watch
CreateConnector Method
CreateConnector
rpc CreateConnector(CreateConnectorRequest) returns (Connector)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/connectors.create
The equivalent REST API is:
POST /v1/connectors (BODY: connector)
POST /v1/{parent=projects/*}/connectors
UpdateConnector Method
UpdateConnector
rpc UpdateConnector(UpdateConnectorRequest) returns (Connector)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/connectors.update
The equivalent REST API is:
PUT /v1/{connector.name=connectors/*} (BODY: connector)
PUT /v1/{connector.name=projects/*/connectors/*}
DeleteConnector Method
DeleteConnector
rpc DeleteConnector(DeleteConnectorRequest) returns (Empty)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/connectors.delete
The equivalent REST API is:
DELETE /v1/{name=connectors/*}
DELETE /v1/{name=projects/*/connectors/*}
ConnectOauth Method
ConnectOauth
rpc ConnectOauth(ConnectOauthRequest) returns (ConnectOauthResponse)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/connectors.connectOauth
The equivalent REST API is:
POST /v1/{name=connectors/*}:connectOauth
POST /v1/{name=projects/*/connectors/*}:connectOauth
Connector Messages
Here is the list of Connector resource messages:
Connector Message
| Name | Type | Description |
|---|
| name | string (name of Connector) | Name of Connector When creating a new instance, this field is optional and if not provided, it will be generated automatically. Last ID segment must conform to the following regex: [a-z][a-z0-9\-]{0,28}[a-z0-9] |
| metadata | Meta | Metadata is an object with information like create, update and delete time (for async deleted resources), has user labels/annotations, sharding information, multi-region syncing information and may have non-schema owners (useful for taking ownership of resources belonging to lower level services by higher ones). |
| display_name | string | Human-readable display name |
| description | string | Human-readable description |
| type | Connector.Type | |
| mcp_config | MCPConfig | MCP connection configuration |
| connect_timeout | .google.protobuf.Duration | Connection timeout |
| request_timeout | .google.protobuf.Duration | Request timeout |
| oauth_config | OAuthConfig | Effective OAuth configuration (static or auto-populated). |
GetConnectorRequest Message
A request message of the GetConnector method.
| Name | Type | Description |
|---|
| name | string (name of Connector) | Name of ntt.ai.v1.Connector |
| field_mask | .google.protobuf.FieldMask | A list of extra fields to be obtained for each response item on top of fields defined by request field view |
| view | View | View defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask |
BatchGetConnectorsRequest Message
A request message of the BatchGetConnectors method.
| Name | Type | Description |
|---|
| names | repeated string (name of Connector) | Names of Connectors |
| field_mask | .google.protobuf.FieldMask | A list of extra fields to be obtained for each response item on top of fields defined by request field view |
| view | View | View defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask |
BatchGetConnectorsResponse Message
A response message of the BatchGetConnectors method.
| Name | Type | Description |
|---|
| connectors | repeated Connector | found Connectors |
| missing | repeated string (name of Connector) | list of not found Connectors |
ListConnectorsRequest Message
A request message of the ListConnectors method.
| Name | Type | Description |
|---|
| parent | string (parent name of Connector) | Parent name of ntt.ai.v1.Connector |
| page_size | int32 | Requested page size. Server may return fewer Connectors than requested. If unspecified, server will pick an appropriate default. |
| page_token | string (cursor of Connector) | A token identifying a page of results the server should return. Typically, this is the value of ListConnectorsResponse.next_page_token. |
| order_by | string (orderBy of Connector) | Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination list of field path with order directive, either ‘asc’ or ‘desc’. If direction is not provided, ‘asc’ is assumed. e.g. “state.nested_field asc, state.something.else desc, theme” |
| filter | string (filter of Connector) | Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL |
| field_mask | .google.protobuf.FieldMask | A list of extra fields to be obtained for each response item on top of fields defined by request field view |
| view | View | View defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask |
| include_paging_info | bool | Indicates if list response should contain total count and offset (fields current_offset and total_results_count). |
ListConnectorsResponse Message
A response message of the ListConnectors method.
| Name | Type | Description |
|---|
| connectors | repeated Connector | The list of Connectors |
| prev_page_token | string (cursor of Connector) | A token to retrieve previous page of results. Pass this value in the ListConnectorsRequest.page_token. |
| next_page_token | string (cursor of Connector) | A token to retrieve next page of results. Pass this value in the ListConnectorsRequest.page_token. |
| current_offset | int32 | Current offset from the first page or 0 if no page tokens were given, paging info was not requested or there was an error while trying to get it). Page index can be computed from offset and limit provided in a request. |
| total_results_count | int32 | Number of total Connectors across all pages or 0, if there are no items, paging info was not requested or there was an error while trying to get it. |
WatchConnectorRequest Message
A request message of the WatchConnector method.
| Name | Type | Description |
|---|
| name | string (name of Connector) | Name of ntt.ai.v1.Connector |
| field_mask | .google.protobuf.FieldMask | A list of extra fields to be obtained for each response item on top of fields defined by request field view |
| view | View | View defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask |
WatchConnectorResponse Message
A response message of the WatchConnector method.
WatchConnectorsRequest Message
A request message of the WatchConnectors method.
| Name | Type | Description |
|---|
| type | WatchType | Type of a watch. Identifies how server stream data to a client, which fields in a request are allowed and which fields in response are relevant. |
| parent | string (parent name of Connector) | Parent name of ntt.ai.v1.Connector |
| page_size | int32 | Requested page size. Server may return fewer Connectors than requested. If unspecified, server will pick an appropriate default. Can be populated only for stateful watch type. |
| page_token | string (cursor of Connector) | A token identifying a page of results the server should return. Can be populated only for stateful watch type. |
| order_by | string (orderBy of Connector) | Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination Can be populated only for stateful watch type. |
| resume_token | string | A token identifying watch resume point from previous session. Can be populated only for stateless watch type. |
| starting_time | .google.protobuf.Timestamp | Point in the time from which we want to start getting updates. This field can be populated only for stateless watch type and if resume token is not known yet. If specified, initial snapshot will NOT be provided. It is assumed client can obtain it using separate means. Watch responses will contain resume tokens which should be used to resume broken connection. |
| filter | string (filter of Connector) | Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL |
| field_mask | .google.protobuf.FieldMask | A list of extra fields to be obtained for each response item on top of fields defined by request field view Changes to Connector that don’t affect any of masked fields won’t be sent back. |
| view | View | View defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask Changes to Connector that don’t affect any of masked fields won’t be sent back. |
| max_chunk_size | int32 | Maximum amount of changes in each response message. Query result response is divided on the server side into chunks with size of a specified amount to limit memory footprint of each message. Responses will hold information whether more elements will continue for the actual change. If unspecified, server will pick an appropriate default. |
WatchConnectorsResponse Message
A response message of the WatchConnectors method.
| Name | Type | Description |
|---|
| connector_changes | repeated ConnectorChange | Changes of Connectors |
| is_current | bool | If request specified max_chunk_size (or this limit was enforced if stateless watch has been chosen), then responses with “full changeset” will be divided into chunks. Client should keep receiving messages and, once is_current has value true, combine this recent message with all previous ones where is_current is false. If this is the first is_current in a whole watch stream, then it means that client should have, at this moment, contain snapshot of the current situation (or more accurately, snapshot of situation at the moment of request). All Connectors will be of type Added/Current (depending on watch_type specified in the request). Further responses will be incremental - however messages may still be chunked and is_current logic still applies. is_current is always true for stateful watch if max_chunk_size was left to 0. |
| page_token_change | WatchConnectorsResponse.PageTokenChange | When present, PageTokens used for page navigation should be updated. Present only if is_current is true (last chunk). |
| resume_token | string | Token that can be used if current connection drops and client needs to reconnect. Populated only for stateless watch type. Present only if is_current is true (last chunk). |
| snapshot_size | int64 | Server may occasionally send information how many resources should client have in its state so far (response message without any changes, but with snapshot_size field specified). If client has different value than the one sent by the server, then it should be treated by a client as an error and should reconnect. If value is smaller then 0, then client should ignore this field as unpopulated. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will be never sent together with is_current, is_soft_reset and is_hard_reset flags. |
| is_soft_reset | bool | In case of internal issue server may send response message with this flag. It indicates that client should drop all changes from recent responses where is_current is false only! If last message had is_current set to true, client should do nothing and process normally. Resume token received before is still valid. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will never be sent along with is_current, is_hard_reset or snapshot_size. |
| is_hard_reset | bool | In case of internal issue server may send response message with this flag. After receiving, client should clear whole state (drop all changes received so far) as server will send new snapshot (Connectors will contains changes of type Current only). Any resume tokens should be discarded as well. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will never be sent along with is_current, is_soft_reset or snapshot_size. |
WatchConnectorsResponse.PageTokenChange Message
| Name | Type | Description |
|---|
| prev_page_token | string (cursor of Connector) | New token to retrieve previous page of results. |
| next_page_token | string (cursor of Connector) | New token to retrieve next page of results. |
CreateConnectorRequest Message
A request message of the CreateConnector method.
CreateConnectorRequest.ResponseMask Message
ResponseMask allows client to reduce response message size.
| Name | Type | Description |
|---|
| skip_entire_response_body | bool | If this flag has value true, then response will contain just empty resource without any fields populated. |
| body_mask | .google.protobuf.FieldMask | If this field is populated, then resource in response will contain only specific fields. |
UpdateConnectorRequest Message
A request message of the UpdateConnector method.
| Name | Type | Description |
|---|
| connector | Connector | Connector resource body |
| update_mask | .google.protobuf.FieldMask | FieldMask applied to request - change will be applied only for fields in the mask |
| cas | UpdateConnectorRequest.CAS | Conditional update applied to request if update should be executed only for specific resource state. If this field is populated, then server will fetch existing resource, compare with the one stored in the cas field (after applying field mask) and proceed with update only and only if they match. Otherwise RPC error Aborted will be returned. |
| allow_missing | bool | If set to true, and the resource is not found, a new resource will be created. In this situation, ‘field_mask’ is ignored. https://google.aip.dev/134#create-or-update |
| response_mask | UpdateConnectorRequest.ResponseMask | reduce message response size. |
UpdateConnectorRequest.CAS Message
CAS - Compare and Swap. This object is used if user wants to make update
conditional based upon previous resource version.
| Name | Type | Description |
|---|
| conditional_state | Connector | Conditional desired state of a resource before update. |
| field_mask | .google.protobuf.FieldMask | Field paths from conditional state of resource server should check and compare. |
UpdateConnectorRequest.ResponseMask Message
ResponseMask allows client to reduce response message size.
| Name | Type | Description |
|---|
| skip_entire_response_body | bool | If this flag has value true, then response will contain just empty resource without any fields populated. Field body_mask is ignored if set. |
| updated_fields_only | bool | Include all fields that were actually updated during processing. Note this may be larger than update mask if some fields were computed additionally. Name is added as well. |
| body_mask | .google.protobuf.FieldMask | If this field is populated, then resource in response will contain only specific fields. If skip_entire_response_body is true, this field is ignored. |
DeleteConnectorRequest Message
A request message of the DeleteConnector method.
| Name | Type | Description |
|---|
| name | string (name of Connector) | Name of ntt.ai.v1.Connector |
| allow_missing | bool | If set to true, and the resource is not found, method will be successful and will not return NotFound error. |
ConnectOauthRequest Message
A request message of the ConnectOauth method.
ConnectOauthResponse Message
A response message of the ConnectOauth method.
Connector Enumerations
Here is the list of Connector resource enumerations:
Connector.Type Enumeration
Connector type
ConnectorUserToken Resource
ConnectorUserToken Resource
Name patterns:
connectorUserTokens/{connector_user_token}projects/{project}/connectorUserTokens/{connector_user_token}
Parent resources:
This section covers the methods
and messages to interact
with ConnectorUserToken resource.
ConnectorUserToken Methods
Here is the list of ConnectorUserToken resource methods:
GetConnectorUserToken Method
GetConnectorUserToken
rpc GetConnectorUserToken(GetConnectorUserTokenRequest) returns (ConnectorUserToken)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/connectorUserTokens.get
The equivalent REST API is:
GET /v1/{name=connectorUserTokens/*}
GET /v1/{name=projects/*/connectorUserTokens/*}
BatchGetConnectorUserTokens Method
BatchGetConnectorUserTokens
rpc BatchGetConnectorUserTokens(BatchGetConnectorUserTokensRequest) returns (BatchGetConnectorUserTokensResponse)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/connectorUserTokens.batchGet
The equivalent REST API is:
GET /v1/connectorUserTokens:batchGet
ListConnectorUserTokens Method
ListConnectorUserTokens
rpc ListConnectorUserTokens(ListConnectorUserTokensRequest) returns (ListConnectorUserTokensResponse)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/connectorUserTokens.list
The equivalent REST API is:
GET /v1/connectorUserTokens
GET /v1/{parent=projects/*}/connectorUserTokens
WatchConnectorUserToken Method
WatchConnectorUserToken
rpc WatchConnectorUserToken(WatchConnectorUserTokenRequest) returns (WatchConnectorUserTokenResponse)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/connectorUserTokens.watch
The equivalent REST API is:
POST /v1/{name=connectorUserTokens/*}:watch
POST /v1/{name=projects/*/connectorUserTokens/*}:watch
WatchConnectorUserTokens Method
WatchConnectorUserTokens
rpc WatchConnectorUserTokens(WatchConnectorUserTokensRequest) returns (WatchConnectorUserTokensResponse)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/connectorUserTokens.watch
The equivalent REST API is:
POST /v1/connectorUserTokens:watch
POST /v1/{parent=projects/*}/connectorUserTokens:watch
CreateConnectorUserToken Method
CreateConnectorUserToken
rpc CreateConnectorUserToken(CreateConnectorUserTokenRequest) returns (ConnectorUserToken)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/connectorUserTokens.create
The equivalent REST API is:
POST /v1/connectorUserTokens (BODY: connector_user_token)
POST /v1/{parent=projects/*}/connectorUserTokens
UpdateConnectorUserToken Method
UpdateConnectorUserToken
rpc UpdateConnectorUserToken(UpdateConnectorUserTokenRequest) returns (ConnectorUserToken)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/connectorUserTokens.update
The equivalent REST API is:
PUT /v1/{connector_user_token.name=connectorUserTokens/*} (BODY: connector_user_token)
PUT /v1/{connector_user_token.name=projects/*/connectorUserTokens/*}
DeleteConnectorUserToken Method
DeleteConnectorUserToken
rpc DeleteConnectorUserToken(DeleteConnectorUserTokenRequest) returns (Empty)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/connectorUserTokens.delete
The equivalent REST API is:
DELETE /v1/{name=connectorUserTokens/*}
DELETE /v1/{name=projects/*/connectorUserTokens/*}
ConnectorUserToken Messages
Here is the list of ConnectorUserToken resource messages:
ConnectorUserToken Message
| Name | Type | Description |
|---|
| name | string (name of ConnectorUserToken) | Name of ConnectorUserToken When creating a new instance, this field is optional and if not provided, it will be generated automatically. Last ID segment must conform to the following regex: [a-z][a-z0-9\-]{0,28}[a-z0-9] |
| metadata | Meta | Metadata is an object with information like create, update and delete time (for async deleted resources), has user labels/annotations, sharding information, multi-region syncing information and may have non-schema owners (useful for taking ownership of resources belonging to lower level services by higher ones). |
| connector | string (name of Connector) | Connector resource this token authorizes against. |
| owner_email | string | IAM user email that established this token. |
| provider_subject | string | Provider specific identifier for the linked account (e.g. subject claim). |
| provider_display_name | string | Provider supplied display name for the linked identity. |
| provider_avatar_url | string | Provider supplied avatar URL for the linked identity. |
| granted_scopes | repeated string | OAuth scopes that were granted for this token. |
| access_token_expires_at | .google.protobuf.Timestamp | Expiration (if any) for the current access token. |
| refresh_token_expires_at | .google.protobuf.Timestamp | Expiration (if any) for the refresh token. |
| last_refresh_time | .google.protobuf.Timestamp | Last time the backend refreshed token material. |
| revoked | bool | Indicates whether this token has been revoked server-side. |
| revoked_time | .google.protobuf.Timestamp | When the token was revoked server-side. |
| revocation_reason | string | Optional human readable reason for revocation. |
| consent_obtained | bool | True once the user has completed any configured downstream consent flow for this connector (for example, granting access to additional provider resources such as Azure Data Explorer). This allows the backend to distinguish between initial connector login and subsequent provider-level consent requirements. |
| secret | ConnectorUserTokenSecret | Encrypted token material, only accepted from the server-side control plane. |
GetConnectorUserTokenRequest Message
A request message of the GetConnectorUserToken method.
| Name | Type | Description |
|---|
| name | string (name of ConnectorUserToken) | Name of ntt.ai.v1.ConnectorUserToken |
| field_mask | .google.protobuf.FieldMask | A list of extra fields to be obtained for each response item on top of fields defined by request field view |
| view | View | View defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask |
BatchGetConnectorUserTokensRequest Message
A request message of the BatchGetConnectorUserTokens method.
| Name | Type | Description |
|---|
| names | repeated string (name of ConnectorUserToken) | Names of ConnectorUserTokens |
| field_mask | .google.protobuf.FieldMask | A list of extra fields to be obtained for each response item on top of fields defined by request field view |
| view | View | View defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask |
BatchGetConnectorUserTokensResponse Message
A response message of the BatchGetConnectorUserTokens method.
| Name | Type | Description |
|---|
| connector_user_tokens | repeated ConnectorUserToken | found ConnectorUserTokens |
| missing | repeated string (name of ConnectorUserToken) | list of not found ConnectorUserTokens |
ListConnectorUserTokensRequest Message
A request message of the ListConnectorUserTokens method.
| Name | Type | Description |
|---|
| parent | string (parent name of ConnectorUserToken) | Parent name of ntt.ai.v1.ConnectorUserToken |
| page_size | int32 | Requested page size. Server may return fewer ConnectorUserTokens than requested. If unspecified, server will pick an appropriate default. |
| page_token | string (cursor of ConnectorUserToken) | A token identifying a page of results the server should return. Typically, this is the value of ListConnectorUserTokensResponse.next_page_token. |
| order_by | string (orderBy of ConnectorUserToken) | Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination list of field path with order directive, either ‘asc’ or ‘desc’. If direction is not provided, ‘asc’ is assumed. e.g. “state.nested_field asc, state.something.else desc, theme” |
| filter | string (filter of ConnectorUserToken) | Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL |
| field_mask | .google.protobuf.FieldMask | A list of extra fields to be obtained for each response item on top of fields defined by request field view |
| view | View | View defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask |
| include_paging_info | bool | Indicates if list response should contain total count and offset (fields current_offset and total_results_count). |
ListConnectorUserTokensResponse Message
A response message of the ListConnectorUserTokens method.
| Name | Type | Description |
|---|
| connector_user_tokens | repeated ConnectorUserToken | The list of ConnectorUserTokens |
| prev_page_token | string (cursor of ConnectorUserToken) | A token to retrieve previous page of results. Pass this value in the ListConnectorUserTokensRequest.page_token. |
| next_page_token | string (cursor of ConnectorUserToken) | A token to retrieve next page of results. Pass this value in the ListConnectorUserTokensRequest.page_token. |
| current_offset | int32 | Current offset from the first page or 0 if no page tokens were given, paging info was not requested or there was an error while trying to get it). Page index can be computed from offset and limit provided in a request. |
| total_results_count | int32 | Number of total ConnectorUserTokens across all pages or 0, if there are no items, paging info was not requested or there was an error while trying to get it. |
WatchConnectorUserTokenRequest Message
A request message of the WatchConnectorUserToken method.
| Name | Type | Description |
|---|
| name | string (name of ConnectorUserToken) | Name of ntt.ai.v1.ConnectorUserToken |
| field_mask | .google.protobuf.FieldMask | A list of extra fields to be obtained for each response item on top of fields defined by request field view |
| view | View | View defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask |
WatchConnectorUserTokenResponse Message
A response message of the WatchConnectorUserToken method.
WatchConnectorUserTokensRequest Message
A request message of the WatchConnectorUserTokens method.
| Name | Type | Description |
|---|
| type | WatchType | Type of a watch. Identifies how server stream data to a client, which fields in a request are allowed and which fields in response are relevant. |
| parent | string (parent name of ConnectorUserToken) | Parent name of ntt.ai.v1.ConnectorUserToken |
| page_size | int32 | Requested page size. Server may return fewer ConnectorUserTokens than requested. If unspecified, server will pick an appropriate default. Can be populated only for stateful watch type. |
| page_token | string (cursor of ConnectorUserToken) | A token identifying a page of results the server should return. Can be populated only for stateful watch type. |
| order_by | string (orderBy of ConnectorUserToken) | Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination Can be populated only for stateful watch type. |
| resume_token | string | A token identifying watch resume point from previous session. Can be populated only for stateless watch type. |
| starting_time | .google.protobuf.Timestamp | Point in the time from which we want to start getting updates. This field can be populated only for stateless watch type and if resume token is not known yet. If specified, initial snapshot will NOT be provided. It is assumed client can obtain it using separate means. Watch responses will contain resume tokens which should be used to resume broken connection. |
| filter | string (filter of ConnectorUserToken) | Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL |
| field_mask | .google.protobuf.FieldMask | A list of extra fields to be obtained for each response item on top of fields defined by request field view Changes to ConnectorUserToken that don’t affect any of masked fields won’t be sent back. |
| view | View | View defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask Changes to ConnectorUserToken that don’t affect any of masked fields won’t be sent back. |
| max_chunk_size | int32 | Maximum amount of changes in each response message. Query result response is divided on the server side into chunks with size of a specified amount to limit memory footprint of each message. Responses will hold information whether more elements will continue for the actual change. If unspecified, server will pick an appropriate default. |
WatchConnectorUserTokensResponse Message
A response message of the WatchConnectorUserTokens method.
| Name | Type | Description |
|---|
| connector_user_token_changes | repeated ConnectorUserTokenChange | Changes of ConnectorUserTokens |
| is_current | bool | If request specified max_chunk_size (or this limit was enforced if stateless watch has been chosen), then responses with “full changeset” will be divided into chunks. Client should keep receiving messages and, once is_current has value true, combine this recent message with all previous ones where is_current is false. If this is the first is_current in a whole watch stream, then it means that client should have, at this moment, contain snapshot of the current situation (or more accurately, snapshot of situation at the moment of request). All ConnectorUserTokens will be of type Added/Current (depending on watch_type specified in the request). Further responses will be incremental - however messages may still be chunked and is_current logic still applies. is_current is always true for stateful watch if max_chunk_size was left to 0. |
| page_token_change | WatchConnectorUserTokensResponse.PageTokenChange | When present, PageTokens used for page navigation should be updated. Present only if is_current is true (last chunk). |
| resume_token | string | Token that can be used if current connection drops and client needs to reconnect. Populated only for stateless watch type. Present only if is_current is true (last chunk). |
| snapshot_size | int64 | Server may occasionally send information how many resources should client have in its state so far (response message without any changes, but with snapshot_size field specified). If client has different value than the one sent by the server, then it should be treated by a client as an error and should reconnect. If value is smaller then 0, then client should ignore this field as unpopulated. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will be never sent together with is_current, is_soft_reset and is_hard_reset flags. |
| is_soft_reset | bool | In case of internal issue server may send response message with this flag. It indicates that client should drop all changes from recent responses where is_current is false only! If last message had is_current set to true, client should do nothing and process normally. Resume token received before is still valid. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will never be sent along with is_current, is_hard_reset or snapshot_size. |
| is_hard_reset | bool | In case of internal issue server may send response message with this flag. After receiving, client should clear whole state (drop all changes received so far) as server will send new snapshot (ConnectorUserTokens will contains changes of type Current only). Any resume tokens should be discarded as well. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will never be sent along with is_current, is_soft_reset or snapshot_size. |
WatchConnectorUserTokensResponse.PageTokenChange Message
| Name | Type | Description |
|---|
| prev_page_token | string (cursor of ConnectorUserToken) | New token to retrieve previous page of results. |
| next_page_token | string (cursor of ConnectorUserToken) | New token to retrieve next page of results. |
CreateConnectorUserTokenRequest Message
A request message of the CreateConnectorUserToken method.
CreateConnectorUserTokenRequest.ResponseMask Message
ResponseMask allows client to reduce response message size.
| Name | Type | Description |
|---|
| skip_entire_response_body | bool | If this flag has value true, then response will contain just empty resource without any fields populated. |
| body_mask | .google.protobuf.FieldMask | If this field is populated, then resource in response will contain only specific fields. |
UpdateConnectorUserTokenRequest Message
A request message of the UpdateConnectorUserToken method.
| Name | Type | Description |
|---|
| connector_user_token | ConnectorUserToken | ConnectorUserToken resource body |
| update_mask | .google.protobuf.FieldMask | FieldMask applied to request - change will be applied only for fields in the mask |
| cas | UpdateConnectorUserTokenRequest.CAS | Conditional update applied to request if update should be executed only for specific resource state. If this field is populated, then server will fetch existing resource, compare with the one stored in the cas field (after applying field mask) and proceed with update only and only if they match. Otherwise RPC error Aborted will be returned. |
| allow_missing | bool | If set to true, and the resource is not found, a new resource will be created. In this situation, ‘field_mask’ is ignored. https://google.aip.dev/134#create-or-update |
| response_mask | UpdateConnectorUserTokenRequest.ResponseMask | reduce message response size. |
UpdateConnectorUserTokenRequest.CAS Message
CAS - Compare and Swap. This object is used if user wants to make update
conditional based upon previous resource version.
| Name | Type | Description |
|---|
| conditional_state | ConnectorUserToken | Conditional desired state of a resource before update. |
| field_mask | .google.protobuf.FieldMask | Field paths from conditional state of resource server should check and compare. |
UpdateConnectorUserTokenRequest.ResponseMask Message
ResponseMask allows client to reduce response message size.
| Name | Type | Description |
|---|
| skip_entire_response_body | bool | If this flag has value true, then response will contain just empty resource without any fields populated. Field body_mask is ignored if set. |
| updated_fields_only | bool | Include all fields that were actually updated during processing. Note this may be larger than update mask if some fields were computed additionally. Name is added as well. |
| body_mask | .google.protobuf.FieldMask | If this field is populated, then resource in response will contain only specific fields. If skip_entire_response_body is true, this field is ignored. |
DeleteConnectorUserTokenRequest Message
A request message of the DeleteConnectorUserToken method.
| Name | Type | Description |
|---|
| name | string (name of ConnectorUserToken) | Name of ntt.ai.v1.ConnectorUserToken |
| allow_missing | bool | If set to true, and the resource is not found, method will be successful and will not return NotFound error. |
Conversation Resource
Conversation Resource
Name patterns:
projects/{project}/conversations/{conversation}users/{user}/conversations/{conversation}
Parent resources:
This section covers the methods
and messages to interact
with Conversation resource.
Conversation Methods
Here is the list of Conversation resource methods:
GetConversation Method
GetConversation
rpc GetConversation(GetConversationRequest) returns (Conversation)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/conversations.get
The equivalent REST API is:
GET /v1/{name=projects/*/conversations/*}
GET /v1/{name=users/*/conversations/*}
BatchGetConversations Method
BatchGetConversations
rpc BatchGetConversations(BatchGetConversationsRequest) returns (BatchGetConversationsResponse)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/conversations.batchGet
The equivalent REST API is:
GET /v1/conversations:batchGet
ListConversations Method
ListConversations
rpc ListConversations(ListConversationsRequest) returns (ListConversationsResponse)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/conversations.list
The equivalent REST API is:
GET /v1/{parent=projects/*}/conversations
GET /v1/{parent=users/*}/conversations
WatchConversation Method
WatchConversation
rpc WatchConversation(WatchConversationRequest) returns (WatchConversationResponse)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/conversations.watch
The equivalent REST API is:
POST /v1/{name=projects/*/conversations/*}:watch
POST /v1/{name=users/*/conversations/*}:watch
WatchConversations Method
WatchConversations
rpc WatchConversations(WatchConversationsRequest) returns (WatchConversationsResponse)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/conversations.watch
The equivalent REST API is:
POST /v1/{parent=projects/*}/conversations:watch
POST /v1/{parent=users/*}/conversations:watch
CreateConversation Method
CreateConversation
rpc CreateConversation(CreateConversationRequest) returns (Conversation)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/conversations.create
The equivalent REST API is:
POST /v1/{parent=projects/*}/conversations (BODY: conversation)
POST /v1/{parent=users/*}/conversations
UpdateConversation Method
UpdateConversation
rpc UpdateConversation(UpdateConversationRequest) returns (Conversation)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/conversations.update
The equivalent REST API is:
PUT /v1/{conversation.name=projects/*/conversations/*} (BODY: conversation)
PUT /v1/{conversation.name=users/*/conversations/*}
DeleteConversation Method
DeleteConversation
rpc DeleteConversation(DeleteConversationRequest) returns (Empty)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/conversations.delete
The equivalent REST API is:
DELETE /v1/{name=projects/*/conversations/*}
DELETE /v1/{name=users/*/conversations/*}
SearchConversations Method
SearchConversations
rpc SearchConversations(SearchConversationsRequest) returns (SearchConversationsResponse)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/conversations.search
The equivalent REST API is:
GET /v1/{parent=projects/*}/conversations:search
GET /v1/{parent=users/*}/conversations:search
CreateConversationFromPrompt Method
CreateConversationFromPrompt
rpc CreateConversationFromPrompt(CreateConversationFromPromptRequest) returns (Conversation)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/conversations.create
The equivalent REST API is:
POST /v1/{parent=projects/*}/conversations:createFromPrompt (BODY: conversation)
POST /v1/{parent=users/*}/conversations:createFromPrompt
Conversation Messages
Here is the list of Conversation resource messages:
Conversation Message
| Name | Type | Description |
|---|
| name | string (name of Conversation) | Name of Conversation When creating a new instance, this field is optional and if not provided, it will be generated automatically. Last ID segment must conform to the following regex: [a-z][a-z0-9\-]{0,28}[a-z0-9] |
| metadata | Meta | Metadata is an object with information like create, update and delete time (for async deleted resources), has user labels/annotations, sharding information, multi-region syncing information and may have non-schema owners (useful for taking ownership of resources belonging to lower level services by higher ones). |
| title | string | Auto generated display title for the conversation |
| configured_title | string | User configured display title for the conversation |
| archived | bool | Whether the conversation has been archived |
| is_private | bool | Privacy level - if true, only visible to creator Private conversations are only accessible to the user who created them Shared (non-private) conversations are visible to all project members |
| last_activity_time | .google.protobuf.Timestamp | Timestamp of the last activity |
| turns | repeated ConversationTurn | Core conversation data - sequence of turns (each turn = one CreateResponse API call) |
| usage_by_model | map<string, ModelUsageStats> | Aggregate statistics by model (for easy analytics/billing) |
| failed_turns | repeated ConversationTurn | Failed turns - stored separately for audit/debugging These turns ended with STOP_REASON_ERROR and should not be replayed |
| replaced_turn_groups | repeated ReplacedTurnGroup | Groups of replaced turns from resume operations Each resume operation creates a new group, preserving context and order |
| capability_template | string (name of CapabilityTemplate) | Capability template used for this conversation |
GetConversationRequest Message
A request message of the GetConversation method.
| Name | Type | Description |
|---|
| name | string (name of Conversation) | Name of ntt.ai.v1.Conversation |
| field_mask | .google.protobuf.FieldMask | A list of extra fields to be obtained for each response item on top of fields defined by request field view |
| view | View | View defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask |
BatchGetConversationsRequest Message
A request message of the BatchGetConversations method.
| Name | Type | Description |
|---|
| names | repeated string (name of Conversation) | Names of Conversations |
| field_mask | .google.protobuf.FieldMask | A list of extra fields to be obtained for each response item on top of fields defined by request field view |
| view | View | View defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask |
BatchGetConversationsResponse Message
A response message of the BatchGetConversations method.
| Name | Type | Description |
|---|
| conversations | repeated Conversation | found Conversations |
| missing | repeated string (name of Conversation) | list of not found Conversations |
ListConversationsRequest Message
A request message of the ListConversations method.
| Name | Type | Description |
|---|
| parent | string (parent name of Conversation) | Parent name of ntt.ai.v1.Conversation |
| page_size | int32 | Requested page size. Server may return fewer Conversations than requested. If unspecified, server will pick an appropriate default. |
| page_token | string (cursor of Conversation) | A token identifying a page of results the server should return. Typically, this is the value of ListConversationsResponse.next_page_token. |
| order_by | string (orderBy of Conversation) | Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination list of field path with order directive, either ‘asc’ or ‘desc’. If direction is not provided, ‘asc’ is assumed. e.g. “state.nested_field asc, state.something.else desc, theme” |
| filter | string (filter of Conversation) | Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL |
| field_mask | .google.protobuf.FieldMask | A list of extra fields to be obtained for each response item on top of fields defined by request field view |
| view | View | View defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask |
| include_paging_info | bool | Indicates if list response should contain total count and offset (fields current_offset and total_results_count). |
ListConversationsResponse Message
A response message of the ListConversations method.
| Name | Type | Description |
|---|
| conversations | repeated Conversation | The list of Conversations |
| prev_page_token | string (cursor of Conversation) | A token to retrieve previous page of results. Pass this value in the ListConversationsRequest.page_token. |
| next_page_token | string (cursor of Conversation) | A token to retrieve next page of results. Pass this value in the ListConversationsRequest.page_token. |
| current_offset | int32 | Current offset from the first page or 0 if no page tokens were given, paging info was not requested or there was an error while trying to get it). Page index can be computed from offset and limit provided in a request. |
| total_results_count | int32 | Number of total Conversations across all pages or 0, if there are no items, paging info was not requested or there was an error while trying to get it. |
WatchConversationRequest Message
A request message of the WatchConversation method.
| Name | Type | Description |
|---|
| name | string (name of Conversation) | Name of ntt.ai.v1.Conversation |
| field_mask | .google.protobuf.FieldMask | A list of extra fields to be obtained for each response item on top of fields defined by request field view |
| view | View | View defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask |
WatchConversationResponse Message
A response message of the WatchConversation method.
WatchConversationsRequest Message
A request message of the WatchConversations method.
| Name | Type | Description |
|---|
| type | WatchType | Type of a watch. Identifies how server stream data to a client, which fields in a request are allowed and which fields in response are relevant. |
| parent | string (parent name of Conversation) | Parent name of ntt.ai.v1.Conversation |
| page_size | int32 | Requested page size. Server may return fewer Conversations than requested. If unspecified, server will pick an appropriate default. Can be populated only for stateful watch type. |
| page_token | string (cursor of Conversation) | A token identifying a page of results the server should return. Can be populated only for stateful watch type. |
| order_by | string (orderBy of Conversation) | Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination Can be populated only for stateful watch type. |
| resume_token | string | A token identifying watch resume point from previous session. Can be populated only for stateless watch type. |
| starting_time | .google.protobuf.Timestamp | Point in the time from which we want to start getting updates. This field can be populated only for stateless watch type and if resume token is not known yet. If specified, initial snapshot will NOT be provided. It is assumed client can obtain it using separate means. Watch responses will contain resume tokens which should be used to resume broken connection. |
| filter | string (filter of Conversation) | Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL |
| field_mask | .google.protobuf.FieldMask | A list of extra fields to be obtained for each response item on top of fields defined by request field view Changes to Conversation that don’t affect any of masked fields won’t be sent back. |
| view | View | View defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask Changes to Conversation that don’t affect any of masked fields won’t be sent back. |
| max_chunk_size | int32 | Maximum amount of changes in each response message. Query result response is divided on the server side into chunks with size of a specified amount to limit memory footprint of each message. Responses will hold information whether more elements will continue for the actual change. If unspecified, server will pick an appropriate default. |
WatchConversationsResponse Message
A response message of the WatchConversations method.
| Name | Type | Description |
|---|
| conversation_changes | repeated ConversationChange | Changes of Conversations |
| is_current | bool | If request specified max_chunk_size (or this limit was enforced if stateless watch has been chosen), then responses with “full changeset” will be divided into chunks. Client should keep receiving messages and, once is_current has value true, combine this recent message with all previous ones where is_current is false. If this is the first is_current in a whole watch stream, then it means that client should have, at this moment, contain snapshot of the current situation (or more accurately, snapshot of situation at the moment of request). All Conversations will be of type Added/Current (depending on watch_type specified in the request). Further responses will be incremental - however messages may still be chunked and is_current logic still applies. is_current is always true for stateful watch if max_chunk_size was left to 0. |
| page_token_change | WatchConversationsResponse.PageTokenChange | When present, PageTokens used for page navigation should be updated. Present only if is_current is true (last chunk). |
| resume_token | string | Token that can be used if current connection drops and client needs to reconnect. Populated only for stateless watch type. Present only if is_current is true (last chunk). |
| snapshot_size | int64 | Server may occasionally send information how many resources should client have in its state so far (response message without any changes, but with snapshot_size field specified). If client has different value than the one sent by the server, then it should be treated by a client as an error and should reconnect. If value is smaller then 0, then client should ignore this field as unpopulated. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will be never sent together with is_current, is_soft_reset and is_hard_reset flags. |
| is_soft_reset | bool | In case of internal issue server may send response message with this flag. It indicates that client should drop all changes from recent responses where is_current is false only! If last message had is_current set to true, client should do nothing and process normally. Resume token received before is still valid. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will never be sent along with is_current, is_hard_reset or snapshot_size. |
| is_hard_reset | bool | In case of internal issue server may send response message with this flag. After receiving, client should clear whole state (drop all changes received so far) as server will send new snapshot (Conversations will contains changes of type Current only). Any resume tokens should be discarded as well. This field should be checked only for stateless watch. In stateful those kind of errors are handled by the server side. Will never be sent along with is_current, is_soft_reset or snapshot_size. |
WatchConversationsResponse.PageTokenChange Message
| Name | Type | Description |
|---|
| prev_page_token | string (cursor of Conversation) | New token to retrieve previous page of results. |
| next_page_token | string (cursor of Conversation) | New token to retrieve next page of results. |
CreateConversationRequest Message
A request message of the CreateConversation method.
CreateConversationRequest.ResponseMask Message
ResponseMask allows client to reduce response message size.
| Name | Type | Description |
|---|
| skip_entire_response_body | bool | If this flag has value true, then response will contain just empty resource without any fields populated. |
| body_mask | .google.protobuf.FieldMask | If this field is populated, then resource in response will contain only specific fields. |
UpdateConversationRequest Message
A request message of the UpdateConversation method.
| Name | Type | Description |
|---|
| conversation | Conversation | Conversation resource body |
| update_mask | .google.protobuf.FieldMask | FieldMask applied to request - change will be applied only for fields in the mask |
| cas | UpdateConversationRequest.CAS | Conditional update applied to request if update should be executed only for specific resource state. If this field is populated, then server will fetch existing resource, compare with the one stored in the cas field (after applying field mask) and proceed with update only and only if they match. Otherwise RPC error Aborted will be returned. |
| allow_missing | bool | If set to true, and the resource is not found, a new resource will be created. In this situation, ‘field_mask’ is ignored. https://google.aip.dev/134#create-or-update |
| response_mask | UpdateConversationRequest.ResponseMask | reduce message response size. |
UpdateConversationRequest.CAS Message
CAS - Compare and Swap. This object is used if user wants to make update
conditional based upon previous resource version.
| Name | Type | Description |
|---|
| conditional_state | Conversation | Conditional desired state of a resource before update. |
| field_mask | .google.protobuf.FieldMask | Field paths from conditional state of resource server should check and compare. |
UpdateConversationRequest.ResponseMask Message
ResponseMask allows client to reduce response message size.
| Name | Type | Description |
|---|
| skip_entire_response_body | bool | If this flag has value true, then response will contain just empty resource without any fields populated. Field body_mask is ignored if set. |
| updated_fields_only | bool | Include all fields that were actually updated during processing. Note this may be larger than update mask if some fields were computed additionally. Name is added as well. |
| body_mask | .google.protobuf.FieldMask | If this field is populated, then resource in response will contain only specific fields. If skip_entire_response_body is true, this field is ignored. |
DeleteConversationRequest Message
A request message of the DeleteConversation method.
| Name | Type | Description |
|---|
| name | string (name of Conversation) | Name of ntt.ai.v1.Conversation |
| allow_missing | bool | If set to true, and the resource is not found, method will be successful and will not return NotFound error. |
SearchConversationsRequest Message
A request message of the SearchConversations method.
| Name | Type | Description |
|---|
| parent | string (parent name of Conversation) | Parent name of ntt.ai.v1.Conversation |
| page_size | int32 | Requested page size. Server may return fewer Conversations than requested. If unspecified, server will pick an appropriate default. |
| page_token | string (cursor of Conversation) | A token identifying a page of results the server should return. Typically, this is the value of SearchConversationsResponse.next_page_token. |
| order_by | string (orderBy of Conversation) | Order By - https://cloud.google.com/apis/design/design_patterns#list_pagination list of field path with order directive, either ‘asc’ or ‘desc’. If direction is not provided, ‘asc’ is assumed. e.g. “state.nested_field asc, state.something.else desc, theme” |
| filter | string (filter of Conversation) | Filter - filter results by field criteria. Simplified SQL-like syntax with following operators: <=, >=, =, !=, <, >, LIKE, CONTAINS (aliases CONTAIN, HAS, HAVE), IN, IS [NOT] NULL |
| field_mask | .google.protobuf.FieldMask | A list of extra fields to be obtained for each response item on top of fields defined by request field view |
| view | View | View defines list of standard response fields present in response items. Additional fields can be amended by request field field_mask |
| phrase | string | Optional search phrase used to further filter results. |
SearchConversationsResponse Message
A response message of the SearchConversations method.
| Name | Type | Description |
|---|
| conversations | repeated Conversation | The list of Conversations |
| prev_page_token | string (cursor of Conversation) | A token to retrieve previous page of results. Pass this value in the SearchConversationsRequest.page_token. |
| next_page_token | string (cursor of Conversation) | A token to retrieve next page of results. Pass this value in the SearchConversationsRequest.page_token. |
| current_offset | int32 | Current offset from the first page (0 if no page tokens were given). Page index can be computed from offset and limit provided in a request |
| total_results_count | int32 | Number of total Conversations across all pages. |
CreateConversationFromPromptRequest Message
A request message of the CreateConversationFromPrompt method.
| Name | Type | Description |
|---|
| parent | string (parent name of Conversation) | Parent name of ntt.ai.v1.Conversation |
| conversation | Conversation | Conversation resource body |
| user_prompt | string | Initial user prompt used for title generation. Not automatically stored as a turn; server decides how to use it. |
ConversationFeedback Resource
ConversationFeedback Resource
Name patterns:
projects/{project}/conversations/{conversation}/conversationFeedbacks/{conversation_feedback}users/{user}/conversations/{conversation}/conversationFeedbacks/{conversation_feedback}
Parent resources:
This section covers the methods
and messages to interact
with ConversationFeedback resource.
ConversationFeedback Methods
Here is the list of ConversationFeedback resource methods:
GetConversationFeedback Method
GetConversationFeedback
rpc GetConversationFeedback(GetConversationFeedbackRequest) returns (ConversationFeedback)
with the following messages:
Required Permissions:
- services/ai.edgelq.com/permissions/conversationFeedbacks.get
The equivalent REST API is:
[...]
